<!-- This comment will put IE 6, 7 and 8 in quirks mode -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>TIOVX Tutorials: vx_tutorial_image_load_save.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javaScript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<img src="ti_logo.gif">
<tr bgcolor="#CCCCCC"> 
      <td bgcolor="#FFFFFF">
        <hr align="left" noshade size="1">
      </td>
</tr>
<!-- Generated by Doxygen 1.6.1 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="main.html"><span>Main&nbsp;Page</span></a></li>
    </ul>
  </div>
<h1>vx_tutorial_image_load_save.c</h1><a href="vx__tutorial__image__load__save_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">*</span>
<a name="l00003"></a>00003 <span class="comment">* Copyright (c) 2017 Texas Instruments Incorporated</span>
<a name="l00004"></a>00004 <span class="comment">*</span>
<a name="l00005"></a>00005 <span class="comment">* All rights reserved not granted herein.</span>
<a name="l00006"></a>00006 <span class="comment">*</span>
<a name="l00007"></a>00007 <span class="comment">* Limited License.</span>
<a name="l00008"></a>00008 <span class="comment">*</span>
<a name="l00009"></a>00009 <span class="comment">* Texas Instruments Incorporated grants a world-wide, royalty-free, non-exclusive</span>
<a name="l00010"></a>00010 <span class="comment">* license under copyrights and patents it now or hereafter owns or controls to make,</span>
<a name="l00011"></a>00011 <span class="comment">* have made, use, import, offer to sell and sell (&quot;Utilize&quot;) this software subject to the</span>
<a name="l00012"></a>00012 <span class="comment">* terms herein.  With respect to the foregoing patent license, such license is granted</span>
<a name="l00013"></a>00013 <span class="comment">* solely to the extent that any such patent is necessary to Utilize the software alone.</span>
<a name="l00014"></a>00014 <span class="comment">* The patent license shall not apply to any combinations which include this software,</span>
<a name="l00015"></a>00015 <span class="comment">* other than combinations with devices manufactured by or for TI (&quot;TI Devices&quot;).</span>
<a name="l00016"></a>00016 <span class="comment">* No hardware patent is licensed hereunder.</span>
<a name="l00017"></a>00017 <span class="comment">*</span>
<a name="l00018"></a>00018 <span class="comment">* Redistributions must preserve existing copyright notices and reproduce this license</span>
<a name="l00019"></a>00019 <span class="comment">* (including the above copyright notice and the disclaimer and (if applicable) source</span>
<a name="l00020"></a>00020 <span class="comment">* code license limitations below) in the documentation and/or other materials provided</span>
<a name="l00021"></a>00021 <span class="comment">* with the distribution</span>
<a name="l00022"></a>00022 <span class="comment">*</span>
<a name="l00023"></a>00023 <span class="comment">* Redistribution and use in binary form, without modification, are permitted provided</span>
<a name="l00024"></a>00024 <span class="comment">* that the following conditions are met:</span>
<a name="l00025"></a>00025 <span class="comment">*</span>
<a name="l00026"></a>00026 <span class="comment">* *       No reverse engineering, decompilation, or disassembly of this software is</span>
<a name="l00027"></a>00027 <span class="comment">* permitted with respect to any software provided in binary form.</span>
<a name="l00028"></a>00028 <span class="comment">*</span>
<a name="l00029"></a>00029 <span class="comment">* *       any redistribution and use are licensed by TI for use only with TI Devices.</span>
<a name="l00030"></a>00030 <span class="comment">*</span>
<a name="l00031"></a>00031 <span class="comment">* *       Nothing shall obligate TI to provide you with source code for the software</span>
<a name="l00032"></a>00032 <span class="comment">* licensed and provided to you in object code.</span>
<a name="l00033"></a>00033 <span class="comment">*</span>
<a name="l00034"></a>00034 <span class="comment">* If software source code is provided to you, modification and redistribution of the</span>
<a name="l00035"></a>00035 <span class="comment">* source code are permitted provided that the following conditions are met:</span>
<a name="l00036"></a>00036 <span class="comment">*</span>
<a name="l00037"></a>00037 <span class="comment">* *       any redistribution and use of the source code, including any resulting derivative</span>
<a name="l00038"></a>00038 <span class="comment">* works, are licensed by TI for use only with TI Devices.</span>
<a name="l00039"></a>00039 <span class="comment">*</span>
<a name="l00040"></a>00040 <span class="comment">* *       any redistribution and use of any object code compiled from the source code</span>
<a name="l00041"></a>00041 <span class="comment">* and any resulting derivative works, are licensed by TI for use only with TI Devices.</span>
<a name="l00042"></a>00042 <span class="comment">*</span>
<a name="l00043"></a>00043 <span class="comment">* Neither the name of Texas Instruments Incorporated nor the names of its suppliers</span>
<a name="l00044"></a>00044 <span class="comment">*</span>
<a name="l00045"></a>00045 <span class="comment">* may be used to endorse or promote products derived from this software without</span>
<a name="l00046"></a>00046 <span class="comment">* specific prior written permission.</span>
<a name="l00047"></a>00047 <span class="comment">*</span>
<a name="l00048"></a>00048 <span class="comment">* DISCLAIMER.</span>
<a name="l00049"></a>00049 <span class="comment">*</span>
<a name="l00050"></a>00050 <span class="comment">* THIS SOFTWARE IS PROVIDED BY TI AND TI&apos;S LICENSORS &quot;AS IS&quot; AND ANY EXPRESS</span>
<a name="l00051"></a>00051 <span class="comment">* OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES</span>
<a name="l00052"></a>00052 <span class="comment">* OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.</span>
<a name="l00053"></a>00053 <span class="comment">* IN NO EVENT SHALL TI AND TI&apos;S LICENSORS BE LIABLE FOR ANY DIRECT, INDIRECT,</span>
<a name="l00054"></a>00054 <span class="comment">* INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,</span>
<a name="l00055"></a>00055 <span class="comment">* BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,</span>
<a name="l00056"></a>00056 <span class="comment">* DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY</span>
<a name="l00057"></a>00057 <span class="comment">* OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE</span>
<a name="l00058"></a>00058 <span class="comment">* OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED</span>
<a name="l00059"></a>00059 <span class="comment">* OF THE POSSIBILITY OF SUCH DAMAGE.</span>
<a name="l00060"></a>00060 <span class="comment">*</span>
<a name="l00061"></a>00061 <span class="comment">*/</span>
<a name="l00062"></a>00062 
<a name="l00063"></a>00063 
<a name="l00064"></a>00064 
<a name="l00114"></a>00114 <span class="preprocessor">#include &lt;stdio.h&gt;</span>
<a name="l00115"></a>00115 <span class="preprocessor">#include &lt;VX/vx.h&gt;</span>
<a name="l00116"></a>00116 <span class="preprocessor">#include &lt;<a class="code" href="bmp__rd__wr_8h.html">bmp_rd_wr.h</a>&gt;</span>
<a name="l00117"></a>00117 <span class="preprocessor">#include &lt;<a class="code" href="utility_8h.html">utility.h</a>&gt;</span>
<a name="l00118"></a>00118 
<a name="l00120"></a><a class="code" href="vx__tutorial__image__load__save_8c.html#a8118656bb5a60090a1dbffa402168438">00120</a> <span class="preprocessor">#define IN_FILE_NAME       &quot;colors.bmp&quot;</span>
<a name="l00121"></a>00121 <span class="preprocessor"></span>
<a name="l00123"></a><a class="code" href="vx__tutorial__image__load__save_8c.html#a75506823f0db0ef3f4f022cf132dbbbb">00123</a> <span class="preprocessor">#define OUT_FILE_NAME      &quot;vx_tutorial_image_load_save_out.bmp&quot;</span>
<a name="l00124"></a>00124 <span class="preprocessor"></span>
<a name="l00128"></a><a class="code" href="vx__tutorial__image__load__save_8c.html#a9de340eb905bd0b735ec6f0471314c85">00128</a> <span class="keywordtype">void</span> <a class="code" href="vx__tutorial__image__load__save_8c.html#a9de340eb905bd0b735ec6f0471314c85" title="Tutorial Entry Point.">vx_tutorial_image_load_save</a>()
<a name="l00129"></a>00129 {
<a name="l00137"></a>00137     vx_context context;
<a name="l00138"></a>00138     vx_image image;
<a name="l00140"></a>00140     vx_uint32 width, height;
<a name="l00141"></a>00141 
<a name="l00142"></a>00142     printf(<span class="stringliteral">&quot; vx_tutorial_image_load_save: Tutorial Started !!! \n&quot;</span>);
<a name="l00143"></a>00143 
<a name="l00151"></a>00151     context = vxCreateContext();
<a name="l00154"></a>00154     printf(<span class="stringliteral">&quot; Loading file %s ...\n&quot;</span>, <a class="code" href="vx__tutorial__image__load__save_8c.html#a8118656bb5a60090a1dbffa402168438" title="Input file name.">IN_FILE_NAME</a>);
<a name="l00155"></a>00155 
<a name="l00163"></a>00163     image = <a class="code" href="utility_8h.html#af8e9cbbd49ab0dec7850267224548cd6" title="Create a image data object given BMP filename as input.">create_image_from_file</a>(context, <a class="code" href="vx__tutorial__image__load__save_8c.html#a8118656bb5a60090a1dbffa402168438" title="Input file name.">IN_FILE_NAME</a>, vx_false_e);
<a name="l00172"></a>00172     vxQueryImage(image, VX_IMAGE_WIDTH, &amp;width, <span class="keyword">sizeof</span>(vx_uint32));
<a name="l00173"></a>00173     vxQueryImage(image, VX_IMAGE_HEIGHT, &amp;height, <span class="keyword">sizeof</span>(vx_uint32));
<a name="l00176"></a>00176     printf(<span class="stringliteral">&quot; Loaded image of dimensions %d x %d\n&quot;</span>, width, height);
<a name="l00177"></a>00177 
<a name="l00178"></a>00178     printf(<span class="stringliteral">&quot; Saving to file %s ...\n&quot;</span>, <a class="code" href="vx__tutorial__image__load__save_8c.html#a75506823f0db0ef3f4f022cf132dbbbb" title="Output file name.">OUT_FILE_NAME</a>);
<a name="l00179"></a>00179 
<a name="l00188"></a>00188     <a class="code" href="utility_8h.html#a2ffb77a8e510c0236b07306d0eb47a30" title="Save data from image object to BMP file.">save_image_to_file</a>(<a class="code" href="vx__tutorial__image__load__save_8c.html#a75506823f0db0ef3f4f022cf132dbbbb" title="Output file name.">OUT_FILE_NAME</a>, image);
<a name="l00197"></a>00197     vxReleaseImage(&amp;image);
<a name="l00208"></a>00208     vxReleaseContext(&amp;context);
<a name="l00211"></a>00211     printf(<span class="stringliteral">&quot; vx_tutorial_image_load_save: Tutorial Done !!! \n&quot;</span>);
<a name="l00212"></a>00212     printf(<span class="stringliteral">&quot; \n&quot;</span>);
<a name="l00213"></a>00213 }
<a name="l00214"></a>00214 
<a name="l00227"></a><a class="code" href="vx__tutorial__image__load__save_8c.html#af8e9cbbd49ab0dec7850267224548cd6">00227</a> vx_image  <a class="code" href="utility_8h.html#af8e9cbbd49ab0dec7850267224548cd6" title="Create a image data object given BMP filename as input.">create_image_from_file</a>(vx_context context, <span class="keywordtype">char</span> *filename, vx_bool convert_to_gray_scale)
<a name="l00228"></a>00228 {
<a name="l00229"></a>00229     vx_image image = NULL;
<a name="l00230"></a>00230     uint32_t width, height, stride;
<a name="l00231"></a>00231     vx_df_image df;
<a name="l00232"></a>00232     vx_status status;
<a name="l00233"></a>00233     <span class="keywordtype">void</span> *data_ptr, *bmp_file_context;
<a name="l00234"></a>00234 
<a name="l00245"></a>00245     status = <a class="code" href="bmp__rd__wr_8h.html#a9fd09ad0e348951c4af9dbb4c852cfd5" title="Read data from BMP file.">bmp_file_read</a>(
<a name="l00246"></a>00246                 filename,
<a name="l00247"></a>00247                 convert_to_gray_scale,
<a name="l00248"></a>00248                 &amp;width, &amp;height, &amp;stride, &amp;df, &amp;data_ptr,
<a name="l00249"></a>00249                 &amp;bmp_file_context);
<a name="l00252"></a>00252     <span class="keywordflow">if</span>(status==VX_SUCCESS)
<a name="l00253"></a>00253     {
<a name="l00267"></a>00267         image = vxCreateImage(context, width, height, df);
<a name="l00268"></a>00268         status = vxGetStatus((vx_reference)image);
<a name="l00270"></a>00270         <span class="keywordflow">if</span>(status==VX_SUCCESS)
<a name="l00271"></a>00271         {
<a name="l00272"></a>00272 
<a name="l00294"></a>00294             vx_imagepatch_addressing_t image_addr;
<a name="l00295"></a>00295             vx_rectangle_t rect;
<a name="l00296"></a>00296             uint32_t bpp;
<a name="l00297"></a>00297 
<a name="l00298"></a>00298             <span class="keywordflow">if</span>( df == VX_DF_IMAGE_U8 )
<a name="l00299"></a>00299                 bpp = 1;
<a name="l00300"></a>00300             <span class="keywordflow">else</span>
<a name="l00301"></a>00301             <span class="keywordflow">if</span>( df == VX_DF_IMAGE_RGB )
<a name="l00302"></a>00302                 bpp = 3;
<a name="l00303"></a>00303             <span class="keywordflow">else</span>
<a name="l00304"></a>00304             <span class="keywordflow">if</span>( df == VX_DF_IMAGE_RGBX )
<a name="l00305"></a>00305                 bpp = 4;
<a name="l00306"></a>00306             <span class="keywordflow">else</span>
<a name="l00307"></a>00307                 bpp = 1; <span class="comment">/* it should not reach here for BMP files */</span>
<a name="l00308"></a>00308 
<a name="l00309"></a>00309             image_addr.dim_x = width;
<a name="l00310"></a>00310             image_addr.dim_y = height;
<a name="l00311"></a>00311             image_addr.stride_x = bpp;
<a name="l00312"></a>00312             image_addr.stride_y = stride;
<a name="l00313"></a>00313             image_addr.scale_x = VX_SCALE_UNITY;
<a name="l00314"></a>00314             image_addr.scale_y = VX_SCALE_UNITY;
<a name="l00315"></a>00315             image_addr.step_x = 1;
<a name="l00316"></a>00316             image_addr.step_y = 1;
<a name="l00317"></a>00317 
<a name="l00318"></a>00318             rect.start_x = 0;
<a name="l00319"></a>00319             rect.start_y = 0;
<a name="l00320"></a>00320             rect.end_x = width;
<a name="l00321"></a>00321             rect.end_y = height;
<a name="l00322"></a>00322 
<a name="l00323"></a>00323             vxCopyImagePatch(image,
<a name="l00324"></a>00324                 &amp;rect,
<a name="l00325"></a>00325                 0,
<a name="l00326"></a>00326                 &amp;image_addr,
<a name="l00327"></a>00327                 data_ptr,
<a name="l00328"></a>00328                 VX_WRITE_ONLY,
<a name="l00329"></a>00329                 VX_MEMORY_TYPE_HOST
<a name="l00330"></a>00330                 );
<a name="l00331"></a>00331 
<a name="l00333"></a>00333         }
<a name="l00341"></a>00341         <a class="code" href="bmp__rd__wr_8h.html#a2a612b23e595a4ac11ba207c88c03be6" title="Free memory allocated during bmp_file_read.">bmp_file_read_release</a>(bmp_file_context);
<a name="l00343"></a>00343     }
<a name="l00344"></a>00344     <span class="keywordflow">return</span> image;
<a name="l00345"></a>00345 }
<a name="l00346"></a>00346 
<a name="l00355"></a><a class="code" href="vx__tutorial__image__load__save_8c.html#a2ffb77a8e510c0236b07306d0eb47a30">00355</a> vx_status <a class="code" href="utility_8h.html#a2ffb77a8e510c0236b07306d0eb47a30" title="Save data from image object to BMP file.">save_image_to_file</a>(<span class="keywordtype">char</span> *filename, vx_image image)
<a name="l00356"></a>00356 {
<a name="l00357"></a>00357     vx_uint32 width, height;
<a name="l00358"></a>00358     vx_imagepatch_addressing_t image_addr;
<a name="l00359"></a>00359     vx_rectangle_t rect;
<a name="l00360"></a>00360     vx_map_id map_id;
<a name="l00361"></a>00361     vx_df_image df;
<a name="l00362"></a>00362     <span class="keywordtype">void</span> *data_ptr;
<a name="l00363"></a>00363     vx_status status;
<a name="l00364"></a>00364 
<a name="l00369"></a>00369     status = vxGetStatus((vx_reference)image);
<a name="l00371"></a>00371     <span class="keywordflow">if</span>(status==VX_SUCCESS)
<a name="l00372"></a>00372     {
<a name="l00380"></a>00380         vxQueryImage(image, VX_IMAGE_WIDTH, &amp;width, <span class="keyword">sizeof</span>(vx_uint32));
<a name="l00381"></a>00381         vxQueryImage(image, VX_IMAGE_HEIGHT, &amp;height, <span class="keyword">sizeof</span>(vx_uint32));
<a name="l00382"></a>00382         vxQueryImage(image, VX_IMAGE_FORMAT, &amp;df, <span class="keyword">sizeof</span>(vx_df_image));
<a name="l00395"></a>00395         rect.start_x = 0;
<a name="l00396"></a>00396         rect.start_y = 0;
<a name="l00397"></a>00397         rect.end_x = width;
<a name="l00398"></a>00398         rect.end_y = height;
<a name="l00399"></a>00399 
<a name="l00400"></a>00400         status = vxMapImagePatch(image,
<a name="l00401"></a>00401             &amp;rect,
<a name="l00402"></a>00402             0,
<a name="l00403"></a>00403             &amp;map_id,
<a name="l00404"></a>00404             &amp;image_addr,
<a name="l00405"></a>00405             &amp;data_ptr,
<a name="l00406"></a>00406             VX_READ_ONLY,
<a name="l00407"></a>00407             VX_MEMORY_TYPE_HOST,
<a name="l00408"></a>00408             VX_NOGAP_X
<a name="l00409"></a>00409             );
<a name="l00412"></a>00412         <span class="keywordflow">if</span>(status==VX_SUCCESS)
<a name="l00413"></a>00413         {
<a name="l00421"></a>00421             <a class="code" href="bmp__rd__wr_8h.html#a34dec5bef3b7ecc629d59645b1c6306e" title="Write data into BMP file.">bmp_file_write</a>(filename, width, height, image_addr.stride_y, df, data_ptr);
<a name="l00431"></a>00431             vxUnmapImagePatch(image, map_id);
<a name="l00433"></a>00433         }
<a name="l00434"></a>00434     }
<a name="l00435"></a>00435     <span class="keywordflow">return</span> status;
<a name="l00436"></a>00436 }
<a name="l00437"></a>00437 
<a name="l00456"></a><a class="code" href="vx__tutorial__image__load__save_8c.html#abb1f44b0f70eb1480ce3ed7dc7bf4e62">00456</a> vx_status <a class="code" href="utility_8h.html#abb1f44b0f70eb1480ce3ed7dc7bf4e62" title="Load data from BMP file into a previously created vx_image object.">load_image_from_file</a>(vx_image image, <span class="keywordtype">char</span> *filename, vx_bool convert_to_gray_scale)
<a name="l00457"></a>00457 {
<a name="l00458"></a>00458     uint32_t width, height, stride;
<a name="l00459"></a>00459     vx_df_image df;
<a name="l00460"></a>00460     uint32_t img_width, img_height;
<a name="l00461"></a>00461     vx_df_image img_df;
<a name="l00462"></a>00462     vx_status status;
<a name="l00463"></a>00463     <span class="keywordtype">void</span> *data_ptr, *bmp_file_context;
<a name="l00464"></a>00464 
<a name="l00465"></a>00465     status = <a class="code" href="bmp__rd__wr_8h.html#a9fd09ad0e348951c4af9dbb4c852cfd5" title="Read data from BMP file.">bmp_file_read</a>(
<a name="l00466"></a>00466                 filename,
<a name="l00467"></a>00467                 convert_to_gray_scale,
<a name="l00468"></a>00468                 &amp;width, &amp;height, &amp;stride, &amp;df, &amp;data_ptr,
<a name="l00469"></a>00469                 &amp;bmp_file_context);
<a name="l00470"></a>00470 
<a name="l00471"></a>00471     <span class="keywordflow">if</span>(status==VX_SUCCESS)
<a name="l00472"></a>00472     {
<a name="l00473"></a>00473         img_width = img_height = 0;
<a name="l00474"></a>00474 
<a name="l00475"></a>00475         vxQueryImage(image, VX_IMAGE_WIDTH, &amp;img_width, <span class="keyword">sizeof</span>(vx_uint32));
<a name="l00476"></a>00476         vxQueryImage(image, VX_IMAGE_HEIGHT, &amp;img_height, <span class="keyword">sizeof</span>(vx_uint32));
<a name="l00477"></a>00477         vxQueryImage(image, VX_IMAGE_FORMAT, &amp;img_df, <span class="keyword">sizeof</span>(vx_df_image));
<a name="l00478"></a>00478 
<a name="l00479"></a>00479         <span class="keywordflow">if</span>(width==img_width &amp;&amp; height==img_height &amp;&amp; df==img_df)
<a name="l00480"></a>00480         {
<a name="l00481"></a>00481             vx_imagepatch_addressing_t image_addr;
<a name="l00482"></a>00482             vx_rectangle_t rect;
<a name="l00483"></a>00483             uint32_t bpp;
<a name="l00484"></a>00484 
<a name="l00485"></a>00485             <span class="keywordflow">if</span>( df == VX_DF_IMAGE_U8 )
<a name="l00486"></a>00486                 bpp = 1;
<a name="l00487"></a>00487             <span class="keywordflow">else</span>
<a name="l00488"></a>00488             <span class="keywordflow">if</span>( df == VX_DF_IMAGE_RGB )
<a name="l00489"></a>00489                 bpp = 3;
<a name="l00490"></a>00490             <span class="keywordflow">else</span>
<a name="l00491"></a>00491             <span class="keywordflow">if</span>( df == VX_DF_IMAGE_RGBX )
<a name="l00492"></a>00492                 bpp = 4;
<a name="l00493"></a>00493             <span class="keywordflow">else</span>
<a name="l00494"></a>00494                 bpp = 1; <span class="comment">/* it should not reach here for BMP files */</span>
<a name="l00495"></a>00495 
<a name="l00496"></a>00496             image_addr.dim_x = width;
<a name="l00497"></a>00497             image_addr.dim_y = height;
<a name="l00498"></a>00498             image_addr.stride_x = bpp;
<a name="l00499"></a>00499             image_addr.stride_y = stride;
<a name="l00500"></a>00500             image_addr.scale_x = VX_SCALE_UNITY;
<a name="l00501"></a>00501             image_addr.scale_y = VX_SCALE_UNITY;
<a name="l00502"></a>00502             image_addr.step_x = 1;
<a name="l00503"></a>00503             image_addr.step_y = 1;
<a name="l00504"></a>00504 
<a name="l00505"></a>00505             rect.start_x = 0;
<a name="l00506"></a>00506             rect.start_y = 0;
<a name="l00507"></a>00507             rect.end_x = width;
<a name="l00508"></a>00508             rect.end_y = height;
<a name="l00509"></a>00509 
<a name="l00510"></a>00510             vxCopyImagePatch(image,
<a name="l00511"></a>00511                 &amp;rect,
<a name="l00512"></a>00512                 0,
<a name="l00513"></a>00513                 &amp;image_addr,
<a name="l00514"></a>00514                 data_ptr,
<a name="l00515"></a>00515                 VX_WRITE_ONLY,
<a name="l00516"></a>00516                 VX_MEMORY_TYPE_HOST
<a name="l00517"></a>00517                 );
<a name="l00518"></a>00518         }
<a name="l00519"></a>00519         <span class="keywordflow">else</span>
<a name="l00520"></a>00520         {
<a name="l00521"></a>00521             status = VX_ERROR_INVALID_PARAMETERS;
<a name="l00522"></a>00522         }
<a name="l00523"></a>00523         <a class="code" href="bmp__rd__wr_8h.html#a2a612b23e595a4ac11ba207c88c03be6" title="Free memory allocated during bmp_file_read.">bmp_file_read_release</a>(bmp_file_context);
<a name="l00524"></a>00524     }
<a name="l00525"></a>00525     <span class="keywordflow">return</span> status;
<a name="l00526"></a>00526 }
<a name="l00527"></a>00527 
</pre></div></div>

<html>
<table bordercolor="#FFFFFF" bgcolor="#FFFFFF" width="100%">
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF">
        <hr align="left" noshade size="1">
      </td>
</tr>
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" color="#000000"><b><i>
        &copy Copyright 2017 Texas Instruments Incorporated. All rights reserved. </i></b></font></td>
</tr>
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" color="#000000">
        Document generated by <b><i> doxygen </i></b> 1.6.1
  </font></td>
</tr>
</table>
